Imports System
Imports System.Data
'if compile outside the IDE
'compile with 
'vbc /t:exe /r:System.dll /r:system.data.dll /r:system.xml.dll chap12_11.vb

Module Module1
    '   Private Const _
    'sConnection As String = _
    ' "Provider=SQLOLEDB.1;" & _
    ' "Password=321dweksp302axn;" & _
    ' "Persist Security Info=True;" & _
    ' "User ID=sa;" & _
    ' "Initial Catalog=CD;" & _
    ' "Data Source=(local)"

    Private Const sConnection As String = "Provider=Microsoft.Jet.OLEDB.4.0;" _
                                          & "Data Source=C:\HodAmiBooks\59362\Day12\CD.mdb;" _
                                          & "Persist Security Info=False"

    Sub Main()
        Dim sSQL As String
        sSQL = "SELECT ArtistID, ArtistName From Artist"
        Dim objConn _
            As New OleDb.OleDbConnection(sConnection)
        Dim objDataAdapter _
            As New OleDb.OleDbDataAdapter(sSQL, objConn)
        Dim objCommandBuilder _
            As New OleDb.OleDbCommandBuilder(objDataAdapter)
        Dim objDS _
            As New DataSet("Artists")

        Try
            objConn.Open()
        Catch myException As System.Exception
            Console.WriteLine(myException.Message)
        End Try

        If objConn.State = ConnectionState.Open Then
            Try
                objDataAdapter.MissingSchemaAction _
                    = MissingSchemaAction.AddWithKey
                objDataAdapter.Fill(objDS, "Artist")

                objConn.Close()
                Dim objTable As DataTable
                objTable = objDS.Tables("Artist")
                Dim drRows As DataRowCollection
                Dim objCurrentRow As DataRow
                drRows = objTable.Rows

                DisplayTable(objTable)

                Console.Write("About to Edit," & _
                    " press return to start!")
                Console.ReadLine()

                'Delete the row with primary key = 11
                drRows.Find(11)("ArtistName") = "Kent Sharkey"

                Console.Write("After Edit," & _
                    " press return to view results")
                Console.ReadLine()

                DisplayTable(objTable)

                objConn.Open()
                objDataAdapter.Update(objDS, "Artist")

            Catch myException As System.Exception
                Console.WriteLine(myException.Message)
            End Try
            Console.Write("Press Return to End.")
            Console.ReadLine()
        End If
    End Sub
    Sub DisplayTable(ByRef objTable As DataTable)
        Dim objRow As DataRow
        Dim objCol As DataColumn
        Dim i, j As Integer

        For j = 0 To objTable.Columns.Count - 1
            objCol = objTable.Columns(j)
            Console.Write("{0}:{1} ", _
    objCol.ColumnName, _
    objCol.DataType.Name)
        Next
        Console.WriteLine()
        For i = 0 To objTable.Rows.Count - 1
            objRow = objTable.Rows(i)
            Select Case objRow.RowState
                Case DataRowState.Deleted
                    Console.Write("[Deleted]   ")
                Case DataRowState.Modified
                    Console.Write("[Modified]  ")
                Case DataRowState.Added
                    Console.Write("[New]       ")
                Case DataRowState.Unchanged
                    Console.Write("[Unchanged] ")
            End Select
            For j = 0 To objTable.Columns.Count - 1
                If objRow.RowState <> DataRowState.Deleted Then
                    Console.Write("{0} ", _
      objRow.Item(j))
                Else
                    Console.Write("{0} ", _
      objRow.Item(j, DataRowVersion.Original))
                End If
            Next
            Console.WriteLine()
        Next
    End Sub
End Module