Module AllAboutObjects2
    Public Sub Test()
        Dim mySnippet As CodeSnippet
        mySnippet = _
            New CodeSnippet("txtEntry.Text = lblInfo.Text", _
            "Joe", "VB.NET", "Get Label Caption Into Text Box")
        PrintSnippet(mySnippet)
        Console.ReadLine()
    End Sub
    Public Sub PrintSnippet(ByVal objSnippet As Snippet)
        Console.WriteLine(objSnippet.GetSnippet())
    End Sub
End Module

Public Class Snippet
    Public Contents As String
    Public Author As String

    Public Sub New()

    End Sub

    Public Sub New(ByVal Contents As String)
        Me.Contents = Contents
    End Sub

    Public Sub New(ByVal Contents As String, _
            ByVal Author As String)
        Me.Contents = Contents
        Me.Author = Author
    End Sub

    Public Overridable Function GetSnippet() As String
        Dim sTmp As String
        sTmp = "Author: " & Author _
            & System.Environment.NewLine _
            & Contents
        Return sTmp
    End Function
End Class

Public Class CodeSnippet
    Inherits Snippet
    Public Language As String
    Public Purpose As String

    Public Sub New()

    End Sub

    Public Sub New(ByVal Contents As String)
        MyBase.New(Contents)
    End Sub

    Public Sub New(ByVal Contents As String, _
            ByVal Author As String)
        Me.New(Contents)
        Me.Author = Author
    End Sub

    Public Sub New(ByVal Contents As String, _
            ByVal Author As String, _
            ByVal Language As String)
        Me.New(Contents, Author)
        Me.Language = Language
    End Sub

    Public Sub New(ByVal Contents As String, _
            ByVal Author As String, _
            ByVal Language As String, _
            ByVal Purpose As String)
        Me.New(Contents, Author, Language)
        Me.Purpose = Purpose
    End Sub

    Public Overrides Function GetSnippet() As String
        Dim sTmp As String
        sTmp = MyBase.GetSnippet() & _
                System.Environment.NewLine & _
                "Language: " & Language & _
                System.Environment.NewLine & _
                "Purpose: " & Purpose
        Return sTmp
    End Function
End Class
